<template>
  <BasicModal width="800px" :height=600 v-bind="$attrs" @register="register" title="物料列表" @ok="handleSubmit">
    <!-- <div class="pt-3px pr-3px">
        <BasicForm @register="registerForm" :model="model" />
      </div> -->
    <div>
      <BasicTable @register="registerTable">
        <!-- <template #toolbar>
                  <a-button type="primary" @click="handleCreate"> 新增盘点 </a-button>
                </template> -->
      </BasicTable>
    </div>
  </BasicModal>
</template>
<script lang="ts">
import { defineComponent, ref, unref } from 'vue';
import { BasicModal, useModalInner } from '/@/components/Modal';
import { BasicForm, FormSchema, useForm, BasicColumn } from '/@/components/Form/index';
import { getTreeList } from '/@/api/tigerapi/dept';
import { BasicTable, TableAction, useTable } from '/@/components/Table';
import { getItemListByPage } from '/@/api/tigerapi/wms/inventory';

const schemas: FormSchema[] = [
  {
    field: 'ITEM_CODE',
    component: 'Input',
    label: '物料编码',
    colProps: {
      span: 12,
    },
  }
];
//物料列表
export const ItemColumns: BasicColumn[] = [
{
    title: 'ID',
    dataIndex: 'ID',
    resizable: true,
    sorter: true,
    width: 200,
    ifShow: false,
  },
  {
    title: '物料编码',
    dataIndex: 'ITEM_CODE',
    resizable: true,
    sorter: true,
    width: 200,
  },
  {
    title: '物料名称',
    dataIndex: 'ITEM_NAME',
    resizable: true,
    sorter: true,
    width: 180,
  },
];
export default defineComponent({
  components: { BasicModal, BasicForm, BasicTable, TableAction },
  props: {
    userData: { type: Object },
  },
  emit: ['success', 'register'],
  setup(_, { emit }) {
    const modelRef = ref({});
    const [
      registerForm,
      {
        // setFieldsValue,
        // setProps
        updateSchema,
        //validate
      },
    ] = useForm({
      labelWidth: 120,
      schemas,
      showActionButtonGroup: false,
      actionColOptions: {
        span: 24,
      },
    });
    const checkedKeys = ref<Array<string | number>>([]);
    const [registerTable, { getRowSelection,getSelectRows }] = useTable({
      title: '物料列表',
      api: getItemListByPage,
      columns: ItemColumns,
      formConfig: {
        labelWidth: 120,
        schemas
      },
      useSearchForm: true,
      showTableSetting: true,
      rowKey: 'ID',
      rowSelection: { type: 'radio' },
      // rowSelection: {
      //   selectedRowKeys: checkedKeys,

      //   type: 'checkbox',
      //   getCheckboxProps(record: Recordable) {
      //     // Demo: 第一行（id为0）的选择框禁用
      //     // if (record.ITEM_CODE === '390300750') {
      //     //   return { disabled: true };
      //     // } else {
      //     //   return { disabled: false };
      //     // }
      //   },
      //   onSelect: onSelect,
      //   onSelectAll: onSelectAll,
      // },
      //bordered: true,
      showIndexColumn: false,
      // actionColumn: {
      //   width: 80,
      //   title: '操作',
      //   dataIndex: 'action',
      //   slots: { customRender: 'action' },
      //   fixed: 'right' //undefined,
      // },
    });
    const [register, { setModalProps, closeModal }] = useModalInner((data) => {
      setModalProps({ confirmLoading: false });
      data && onDataReceive(data);
    });
    let aa=ref({
      item_code:'',
      item_name:''
    })
    
    async function onDataReceive(data) {
      console.log('Data Received', data);
      // 方式1;
      // setFieldsValue({
      //   field2: data.data,
      //   field1: data.info,
      // });

      // // 方式2
      // modelRef.value = { field2: data.data, field1: data.info };
      // const treeData = await getTreeList();
      // updateSchema([
      //   {
      //     field: 'USER_PWD',
      //     show: !unref(false),
      //   },
      //   {
      //     field: 'ORG_CODE',
      //     componentProps: { treeData },
      //   },
      // ]);
      // setProps({
      //   model:{ field2: data.data, field1: data.info }
      // })
    }

    // function handleVisibleChange(v) {
    //   v && props.userData && nextTick(() => onDataReceive(props.userData));
    // }

    async function handleSubmit() {
      try {
        var _data = '';
        _data = getSelectRows()
        console.log(_data)
        var values = '';
        // checkedKeys.value.forEach(element => {
        //   values+=element;
        // });
        //values = checkedKeys.value.join(',')
        var code=_data[0].ITEM_CODE;
        var name=_data[0].ITEM_NAME;
        closeModal();
        emit('success', {
          isUpdate: unref(false),
          values: { code, name },
        });

      } finally {
        setModalProps({ confirmLoading: false });
      }
    }
    function onSelect(record, selected) {
      if (selected) {
        checkedKeys.value = [...checkedKeys.value, record.ITEM_CODE];
      } else {
        checkedKeys.value = checkedKeys.value.filter((ITEM_CODE) => ITEM_CODE !== record.ITEM_CODE);
      }
    }
    function onSelectAll(selected, selectedRows, changeRows) {
      const changeIds = changeRows.map((item) => item.ITEM_CODE);
      if (selected) {
        checkedKeys.value = [...checkedKeys.value, ...changeIds];
      } else {
        checkedKeys.value = checkedKeys.value.filter((ITEM_CODE) => {
          return !changeIds.includes(ITEM_CODE);
        });
      }
    }

    return {
      register,
      schemas,
      registerForm,
      model: modelRef,
      handleSubmit,
      registerTable,
      onSelect,
      onSelectAll
    };
  },
});
</script>
